<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: OntologiesTable.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: OntologiesTable.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import React, { Component } from "react";
import { BsDownload } from "react-icons/bs";
import { GrDocumentZip } from "react-icons/gr";
import { BiShow } from "react-icons/bi";
import Button from "react-bootstrap/Button";
import BootstrapTable from "react-bootstrap-table-next";
import ToolkitProvider, { ColumnToggle } from "react-bootstrap-table2-toolkit";
import { Accordion, Card } from "react-bootstrap";
import paginationFactory from "react-bootstrap-table2-paginator";
import Spinner from "react-bootstrap/Spinner";
import Modal from "react-bootstrap/Modal";
import ChartPopup from "./ChartPopup";
import ClassesFrequencyDistribution from "./Charts/ClassesFrequencyDistribution";
import InstancesFrequencyDistribution from "./Charts/InstancesFrequencyDistribution";
import AxiomFrequencyDistribution from "./Charts/AxiomFrequencyDistribution";
import AxiomTypesDistribution from "./Charts/AxiomTypesDistribution";
import DLConstructsDistribution from "./Charts/DLConstructsDistribution";
import OWL2ProfilesDistribution from "./Charts/OWL2ProfilesDistribution";
import AnnotationsDistribution from "./Charts/AnnotationsDistribution";
import DomainRangeDefinitionDistribution from "./Charts/DomainRangeDefinitionDistribution";
import { min, median, mean, std, max } from "mathjs";

/**
 * Ontologies table component which displays table of result ontologies
 *
 * @component
 */
class OntologiesTableClass extends Component {
  /** @constructor */
  constructor(props) {
    super(props);
    this.state = {
      isZipping: false,
      showPopup: false,
      popupMessage: "",
      popupTitle: "",
      randomOntologiesNumber: "",
    };
  }

  /**
   * Smooth scroll to the table with result ontologies
   *
   * @method
   */
  scrollToTable = () =>
    this.props.tableRef.current.scrollIntoView({ behavior: "smooth" });

  /**
   * Hides popups on close press
   *
   * @method
   */
  hidePopup = () => {
    this.setState({ showPopup: false });
  };

  /**
   * Saves the number of required ontologies for random subsampling
   *
   * @param {Object} evt - Input element onChange event
   * @method
   */
  randomOntologiesNumberChange = (evt) => {
    this.setState({ randomOntologiesNumber: evt.target.value });
  };

  /**
   * Selects randomly ontologies from actual selection based on entered number
   *
   * @method
   */
  randomSubSampling = () => {
    const { randomOntologiesNumber } = this.state;
    const { data } = this.props;
    // const dataTemp = [...data];

    if (
      Number.isInteger(parseInt(randomOntologiesNumber)) &amp;&amp;
      randomOntologiesNumber > 0 &amp;&amp;
      randomOntologiesNumber &lt; data.length
    ) {
      while (data.length > randomOntologiesNumber) {
        let randomNumber = Math.floor(Math.random() * data.length);
        this.setState({ data: [] });
        data.splice(randomNumber, 1);
      }
      this.setState({ data: data }, () => this.scrollToTable());
    } else {
      this.setState({
        showPopup: true,
        popupMessage: `Please enter a positive number of randomly selected ontologies lower than number of currently selected ontologies (${data.length}).`,
        popupTitle: "Wrong number",
      });
    }
  };

  /**
   * Downloads individual ontology based on storage code
   *
   * @param {Number} code - Storage code of selected ontology
   * @async
   */
  async download(code) {
    const res = await fetch(`/download/${code}`, { method: "POST" });

    const blob = await res.blob();
    const url = window.URL.createObjectURL(blob);
    let link = document.createElement("a");
    link.href = url;
    link.download = `${code}.owl`;
    link.click();
  }

  /**
   * Downloads ontology with all its impots based on storage code
   *
   * @param {Number} code - Storage code of selected ontology
   * @async
   */
  async downloadWithImports(code) {
    const res = await fetch(`/downloadWithImports/${code}`, { method: "POST" });

    const blob = await res.blob();
    const url = window.URL.createObjectURL(blob);
    let link = document.createElement("a");
    link.href = url;
    link.download = `${code}_with_imports.zip`;
    link.click();
  }

  /**
   * Downloads ontology metrics table as a CSV file
   *
   * @method
   */
  downloadMetrics = () => {
    const { data } = this.props;
    const csvString = [
      Object.keys(data[0]),
      ...data.map((item) => {
        return Object.keys(data[0]).map((key) => {
          return item[key];
        });
      }),
    ]
      .map((e) => e.join(","))
      .join("\r\n");
    const blob = new Blob([csvString], { type: "text/csv" });
    const url = window.URL.createObjectURL(blob);
    const link = document.createElement("a");
    link.href = url;
    link.download = `metrics_table.csv`;
    document.body.appendChild(link);
    link.click();
  };

  /**
   * Downloads summary statistics as a CSV file
   *
   * @method
   */
  downloadSummaryStatistics = () => {
    const {
      resourceFilter,
      data,
      filters,
      page,
      word,
      matcher,
      entities,
      scope,
    } = this.props;
    let metricsSelection = "";
    let resource = "";

    if (page === "1") {
      resource = filters.selectedResource;
      metricsSelection = Object.keys(filters)
        .filter((item) => item !== "selectedResource" &amp;&amp; filters[item])
        .map((item) => {
          return `${item}: ${filters[item]}`;
        })
        .join(" and ");
    }

    if (page === "2") {
      resource = resourceFilter;
      metricsSelection = `Word: ${word} and Matcher: ${matcher} and Entities: ${entities} and Scope: ${scope}`;
    }

    const metrics = Object.keys(data[0])
      .filter((item) => {
        return (
          item !== "storage_code" &amp;&amp;
          item !== "URL" &amp;&amp;
          item !== "IRI" &amp;&amp;
          item !== "resource" &amp;&amp;
          item !== "complexity" &amp;&amp;
          item !== "classesExensional" &amp;&amp;
          item !== "maxInstancesInClassesExtensional" &amp;&amp;
          item !== "avgInstancesInClassesExtensional" &amp;&amp;
          item !== "complexityBin" &amp;&amp;
          item !== "avgSubClasses" &amp;&amp;
          item !== "GCICount" &amp;&amp;
          item !== "subclasses" &amp;&amp;
          item !== "constructHasSelf" &amp;&amp;
          item !== "constructOneOf" &amp;&amp;
          item !== "axDisjointUnion" &amp;&amp;
          item !== "axInverseFunctionalOProperties" &amp;&amp;
          item !== "GCICountAPIimport" &amp;&amp;
          item !== "axDisjointUnionAPIimport" &amp;&amp;
          item !== "v5" &amp;&amp;
          item !== "v5avg" &amp;&amp;
          item !== "fc5" &amp;&amp;
          item !== "fc5ratio"
        );
      })
      .map((metric) => {
        return [
          metric,
          data.filter((item) => item[metric] > 0).length,
          min(data.map((item) => item[metric])),
          median(data.map((item) => item[metric])).toFixed(1),
          mean(data.map((item) => item[metric])).toFixed(1),
          std(data.map((item) => item[metric])).toFixed(1),
          max(data.map((item) => item[metric])),
        ];
      });

    const csvString = [
      ["#metrics", "nonzero", "min", "median", "average", "stdev", "max"],
      [`#${data.length} ontologies in collection`],
      [`#selected ontology pool: ${resource}`],
      [`#your metrics selection: ${metricsSelection}`],
      ...metrics,
    ]
      .map((e) => e.join(","))
      .join("\r\n");

    const blob = new Blob([csvString], { type: "text/csv" });
    const url = window.URL.createObjectURL(blob);
    const link = document.createElement("a");
    link.href = url;
    link.download = `summary_statistics.csv`;
    document.body.appendChild(link);
    link.click();
  };

  /**
   * Downloads all currently selected ontologies
   *
   * @method
   */
  downloadAllOntologies = async () => {
    const {
      data,
      filters,
      page,
      word,
      matcher,
      entities,
      scope,
      resourceFilter,
    } = this.props;

    if (data.length) {
      this.setState({ isZipping: true });
      try {
        const res = await fetch(`/downloadAll`, {
          method: "POST",
          headers: {
            "Content-Type": "application/json",
            Accept: "application/zip",
          },
          body: JSON.stringify({
            storage_codes: data.map((item) => item.storage_code),
            metrics: filters || {
              word,
              matcher,
              entities,
              scope,
              resourceFilter,
            },
            page: page,
          }),
        });
        if (res.status === 413) {
          const data = await res.json();
          this.setState({
            showPopup: true,
            popupMessage: data.message,
            popupTitle: "Error",
          });
        } else {
          const blob = await res.blob();
          const url = window.URL.createObjectURL(blob);
          let link = document.createElement("a");
          link.href = url;
          link.download = "ontologies.zip";
          link.click();
        }
      } catch (e) {
        console.error(e);
      }
      this.setState({ isZipping: false });
    }
  };

  /**
   * Formats first column of the ontology result table to display buttons
   *
   * @param {Object} cell - current cell
   * @param {Object} row  - current row
   * @returns formatted cells
   * @method
   */
  actionFormatter = (cell, row) => {
    return (
      &lt;>
        &lt;BiShow
          onClick={() =>
            window.open(
              `http://visualdataweb.de/webvowl/#iri=https://owl.vse.cz/ontologies/${row.storage_code}.owl`
            )
          }
          cursor="pointer"
          style={{ margin: "0 3px" }}
        />

        &lt;BsDownload
          onClick={() => this.download(row.storage_code)}
          cursor="pointer"
          style={{ margin: "0 3px" }}
        />

        &lt;GrDocumentZip
          onClick={() => this.downloadWithImports(row.storage_code)}
          cursor="pointer"
          style={{ margin: "0 3px" }}
        />
      &lt;/>
    );
  };

  /**
   * Checks if column should be initially shown or hidden
   *
   * @param {String} header - name of the column
   * @returns TRUE if should be hidden, FALSE if not
   * @method
   */
  isHidden = (header) => {
    const notHiddenColumns = ["storage_code", "IRI", "resource"];

    return !notHiddenColumns.includes(header);
  };

  /**
   * Renders ontology result table
   *
   * @method
   */
  render() {
    const { ToggleList } = ColumnToggle;
    const { data } = this.props;
    const {
      isZipping,
      showPopup,
      popupMessage,
      popupTitle,
      randomOntologiesNumber,
    } = this.state;
    const headers = data.length > 0 ? Object.keys(data[0]) : null;
    let table, buttonDownloadAll;

    if (headers) {
      const columns = headers.map((header) => {
        return {
          text: header,
          dataField: header,
          hidden: this.isHidden(header),
        };
      });
      columns.unshift({
        text: "Actions",
        dataField: "actions",
        isDummyField: true,
        formatter: this.actionFormatter,
      });

      if (isZipping) {
        buttonDownloadAll = (
          &lt;>
            &lt;Button variant="primary" disabled>
              &lt;Spinner
                as="span"
                animation="border"
                size="sm"
                role="status"
                aria-hidden="true"
              />
              &lt;span className="sr-only">Loading...&lt;/span>
            &lt;/Button>
          &lt;/>
        );
      } else {
        buttonDownloadAll = (
          &lt;Button onClick={() => this.downloadAllOntologies()}>
            Download all ({data.length})
          &lt;/Button>
        );
      }

      table = (
        &lt;ToolkitProvider
          keyField="storage_code"
          data={data}
          columns={columns}
          columnToggle
        >
          {(props) => (
            &lt;div>
              &lt;div className="random-subsampling">
                &lt;hr />
                Number of ontologies which will be randomly selected for your
                experimental ontology set:
                &lt;br />
                &lt;Button onClick={this.randomSubSampling}>
                  Random sub-sampling
                &lt;/Button>
                &lt;input
                  value={randomOntologiesNumber}
                  onChange={this.randomOntologiesNumberChange}
                />
              &lt;/div>
              &lt;hr />
              &lt;div className="chart-group">
                &lt;h5>Graphs for Ontology Set Statistics&lt;/h5>
                &lt;ChartPopup
                  chart={&lt;ClassesFrequencyDistribution data={data} />}
                  name="Class frequency distribution"
                />
                &lt;ChartPopup
                  chart={&lt;InstancesFrequencyDistribution data={data} />}
                  name="Instances frequency distribution"
                />
                &lt;ChartPopup
                  chart={&lt;AxiomFrequencyDistribution data={data} />}
                  name="Axiom frequency distribution"
                />
                &lt;ChartPopup
                  chart={&lt;AxiomTypesDistribution data={data} />}
                  name="Axiom types distribution"
                />
                &lt;ChartPopup
                  chart={&lt;DLConstructsDistribution data={data} />}
                  name="DL constructs distribution"
                />
                &lt;ChartPopup
                  chart={&lt;OWL2ProfilesDistribution data={data} />}
                  name="OWL2 profiles distribution"
                />
                &lt;ChartPopup
                  chart={&lt;AnnotationsDistribution data={data} />}
                  name="Annotations distribution"
                />
                &lt;ChartPopup
                  chart={&lt;DomainRangeDefinitionDistribution data={data} />}
                  name="Domain/Range definition distribution"
                />
              &lt;/div>
              &lt;hr />
              &lt;p className="download-info">
                You can download all selected ontologies by clicking "Download
                all" button below, open ontology in WebVOWL by clicking{" "}
                &lt;BiShow /> icon, download individual ontology by clicking{" "}
                &lt;BsDownload /> icon or download ontology with its imports as a
                zip file by clicking &lt;GrDocumentZip /> icon.
              &lt;/p>

              &lt;div className="ontologies-table-btn-group">
                {buttonDownloadAll}
                &lt;Button onClick={() => this.downloadSummaryStatistics()}>
                  Download summary statistics
                &lt;/Button>
                &lt;Button onClick={() => this.downloadMetrics()}>
                  Download ontology metrics table
                &lt;/Button>
              &lt;/div>

              &lt;Accordion
                className="ontology-table-columns-toggle-accordion"
                ref={this.props.tableRef}
              >
                &lt;Card>
                  &lt;Accordion.Toggle as={Card.Header} eventKey="0">
                    Show/Hide Columns
                  &lt;/Accordion.Toggle>
                  &lt;Accordion.Collapse eventKey="0">
                    &lt;Card.Body>
                      &lt;ToggleList
                        {...props.columnToggleProps}
                        btnClassName="ontology-table-columns-toggle-item"
                        className="ontology-table-columns-toggle"
                      />
                    &lt;/Card.Body>
                  &lt;/Accordion.Collapse>
                &lt;/Card>
              &lt;/Accordion>

              &lt;br />

              &lt;BootstrapTable
                {...props.baseProps}
                pagination={paginationFactory()}
              />
            &lt;/div>
          )}
        &lt;/ToolkitProvider>
      );
    } else {
      table = "";
    }

    return (
      &lt;div>
        &lt;Modal show={showPopup} onHide={this.hidePopup}>
          &lt;Modal.Header closeButton>
            &lt;Modal.Title>{popupTitle}&lt;/Modal.Title>
          &lt;/Modal.Header>
          &lt;Modal.Body>{popupMessage}&lt;/Modal.Body>
          {/* &lt;Modal.Footer>
    &lt;Button variant="secondary" onClick={handleClose}>Close&lt;/Button>
    &lt;Button variant="primary" onClick={handleClose}>
      Save Changes
    &lt;/Button>
  &lt;/Modal.Footer> */}
        &lt;/Modal>
        {table}
      &lt;/div>
    );
  }
}

export default OntologiesTableClass;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="-_1.html">_1</a></li><li><a href="-_2.html">_2</a></li><li><a href="AnnotationMetricsFilters.html">AnnotationMetricsFilters</a></li><li><a href="AnnotationsDistribution.html">AnnotationsDistribution</a></li><li><a href="AxiomFrequencyDistribution.html">AxiomFrequencyDistribution</a></li><li><a href="AxiomMetricsFilters.html">AxiomMetricsFilters</a></li><li><a href="AxiomTypesDistribution.html">AxiomTypesDistribution</a></li><li><a href="ChartPopup.html">ChartPopup</a></li><li><a href="ClassesFrequencyDistribution.html">ClassesFrequencyDistribution</a></li><li><a href="ClassExpressionTypeMetricsFilters.html">ClassExpressionTypeMetricsFilters</a></li><li><a href="DetailMetricsFilters.html">DetailMetricsFilters</a></li><li><a href="DLConstructsDistribution.html">DLConstructsDistribution</a></li><li><a href="DomainRangeDefinitionDistribution.html">DomainRangeDefinitionDistribution</a></li><li><a href="EntitiyMetricsFilters.html">EntitiyMetricsFilters</a></li><li><a href="Home.html">Home</a></li><li><a href="InstancesFrequencyDistribution.html">InstancesFrequencyDistribution</a></li><li><a href="Navigation.html">Navigation</a></li><li><a href="OntologiesTableClass.html">OntologiesTableClass</a></li><li><a href="OWL2ProfilesAndReasoning.html">OWL2ProfilesAndReasoning</a></li><li><a href="OWL2ProfilesDistribution.html">OWL2ProfilesDistribution</a></li><li><a href="ResourceFilter.html">ResourceFilter</a></li><li><a href="Tab.html">Tab</a></li><li><a href="Tabs.html">Tabs</a></li><li><a href="TaxonomyMetricsFilters.html">TaxonomyMetricsFilters</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.6</a> on Sun Apr 11 2021 17:29:26 GMT+0200 (stredoeurópsky letný čas)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
